package com.iformall.mapper;

import java.util.*;
import com.iformall.common.CommonMapper;
import com.iformall.domain.vo.WxCouponCVo;
import org.apache.ibatis.annotations.Param;
import com.iformall.domain.po.WxCoupon;

public interface WxCouponMapper extends CommonMapper<WxCoupon, Long> {
	List<WxCoupon> findPressData(WxCoupon wxCoupon);
	List<WxCoupon> findCouponData(WxCoupon wxCoupon);
	List<WxCoupon> findCountData(WxCoupon wxCoupon);
	List<WxCoupon> findList(WxCoupon wxCoupon);
	List<WxCoupon> findCardList(WxCoupon wxCoupon);
	List<WxCoupon> findCouponList(WxCoupon wxCoupon);
	List<WxCoupon> findPressList(WxCoupon wxCoupon);

	WxCouponCVo findVoDetail(@Param("id")Long id);

	void reduceInventory(@Param("id")Long id,@Param("number")Integer number);

	void offExpiriedCouponByValidDate();

	void offExpiriedCouponByMerchantStatus();

	/**
	 * 查询时间段内销售金额
	 * @param wxCoupon
	 * @return
	 */
	List<WxCoupon> findSaleMoneyByDate(WxCoupon wxCoupon);

	/**
	 * 查询时间段内核销金额
	 * @param wxCoupon
	 * @return
	 */
	List<WxCoupon> findPaymentByDate(WxCoupon wxCoupon);

	Long findSaleCardCount(WxCoupon wxCoupon);

	Long findTranCardCount(WxCoupon wxCoupon);

	String findSubsidyMoney(WxCoupon wxCoupon);

	//-------卷--------

	List<WxCoupon> findCouponOrderCount(WxCoupon wxCoupon);

	List<WxCoupon> findCouponPaymentCount(WxCoupon wxCoupon);

	List<WxCoupon> priceCouponSaleCount(WxCoupon wxCoupon);

	List<WxCoupon> priceCouponPaymentCount(WxCoupon wxCoupon);

	String findSumPriceSaleMoney(WxCoupon wxCoupon);
	String findSumPricePayMent(WxCoupon wxCoupon);
	String findSumSubsidyMoney(WxCoupon wxCoupon);

	//-------砍价--------
	List<WxCoupon> pressSendHistory(WxCoupon wxCoupon);
	List<WxCoupon> pressSuccHistory(WxCoupon wxCoupon);
	List<WxCoupon> pressPaymentHistory(WxCoupon wxCoupon);
	String pressSuccRate(WxCoupon wxCoupon);
	Long sumJoin(WxCoupon wxCoupon);
}
